MONGOS(1)

NAME
mongos - MongoDB Sharded Cluster Query Router

SYNOPSIS

mongos for "MongoDB Shard," is a routing service for MongoDB shard configurations that processes queries from the application layer, and determines the location of this data in the sharded cluster, in order to complete these operations. From the perspective of the application, a mongos instance behaves identically to any other MongoDB instance.

OPTIONS

  Core Options

mongos

--help, -h
    Returns information on mongos options and usage.

--version
    Returns the mongos release number.

--config <filename>, -f
    Specifies a configuration file for runtime configuration options. The configuration file is the preferred method for runtime configuration of mongos. The options are equivalent to the command-line configuration options. See http://docs.mongodb.org/manual/reference/configuration-options for more information.

    Ensure the configuration file uses ASCII encoding. mongos does not support configuration files with non-ASCII encoding, including UTF-8.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs mongos in a quiet mode that attempts to limit the amount of output. This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--port <port>
    Specifies the port number when the MongoDB instance is not running on the standard port of 27017. You may also specify the port number using the --host option.

--bind_ip <ip address>
    Specifies the IP address that the mongos process binds to and listens for connections on. By default mongos listens for connections for all interfaces. You may attach mongos to any interface. When attaching mongos to a publicly accessible interface, ensure that you have implemented proper authentication and firewall restrictions to protect the integrity of your database.

--maxConns <number>
    Specifies the maximum number of simultaneous connections that mongos will accept. This setting will have no effect if the value of this setting is higher than your operating system's configured maximum connection tracking threshold.

    This setting is particularly useful for mongos if you have a client that creates a number of collections but allows them to timeout rather than close the collections. When you set maxConns, ensure the value is slightly higher than the size of the connection pool or the total number of connections to prevent erroneous connection spikes from propagating to the members of a sharded cluster.

    Changed in version 2.6: MongoDB removed the upward limit on the maxConns setting.

--syslog
    Sends all logging output to the host's syslog system rather than to standard output or a log file as with --logpath.

    --syslog is not supported on Windows.

--syslogFacility <string>
    Specifies the facility level used when logging messages to syslog. The default is user. The value you specify must be supported by your operating system's implementation of syslog. To use this option, you must enable the --syslog option.

--logpath <path>
    Specifies the path for the log file that holds all diagnostic logging information.

    Unless specified, mongos will output all log information to the standard output. Additionally, unless you also specify --logappend, the logfile will be overwritten when the process restarts.

    NOTE: The behavior of the logging system may change in the near future in response to the SERVER-4499 case.

--logappend
    Appends new entries to the end of the logfile when the mongos restarts instead of overwriting the content of the log.

--timeStampFormat <string>
    Specifies the time format for timestamps in log messages. Specify one of the following values:
    Value | Description
    ctime | Displays timestamps as Wed Dec 31 18:17:54.811.
    iso8601-utc | Displays timestamps in Coordinated Universal Time (UTC) in the ISO-8601 format. For example, for New York at the start of the Epoch: 1970-01-01T00:00:00.000Z
    iso8601-local | Default value. Displays timestamps in local time in the ISO-8601 format. For example, for New York at the start of the Epoch: 1969-12-31T19:00:00.000+0500

--pidfilepath <path>
    Specifies a file location to hold the "PID" or process ID of the mongos process. Useful for tracking the mongos process in combination with the --fork option.

    Without a specified --pidfilepath option, mongos creates no PID file.

--keyFile <file>
    Specifies the path to a key file to store authentication information. This option is used for interprocess authentication among the mongos and mongod instances of a sharded cluster or replica set.

--setParameter <options>
    New in version 2.4.

    Specifies an option to configure on startup. Specify multiple options with multiple --setParameter options. See http://docs.mongodb.org/manual/reference/parameters for full documentation of these parameters. The setParameter database command provides access to many of these parameters. --setParameter supports the following options:

•   enableLocalhostAuthBypass

•   enableTestCommands

•   logLevel

•   logUserIds

•   notablescan

•   quiet

•   supportCompatibilityFormPrivilegeDocuments

•   syncdelay

•   textSearchEnabled

•   userCacheInvalidationIntervalSecs

--httpinterface
    New in version 2.6.

    Enables the HTTP interface. Enabling the interface can increase network exposure.

    Leave the HTTP interface disabled for production deployments. If you do enable this interface, you should only allow trusted clients to access this port. See security-firewalls.

    NOTE: In MongoDB Enterprise, the HTTP Console does not support Kerberos Authentication.

--clusterAuthMode <option>
    New in version 2.6.

    Enables internal x.509 authentication for membership to the cluster or replica set. The --clusterAuthMode option can have one of the following values:
    Value | Description
    keyFile | Default value. Use keyfile for authentication.
    sendKeyFile | For rolling upgrade purposes. Send the keyfile for authentication but can accept either keyfile or x.509 certificate.
    sendX509 | For rolling upgrade purposes. Send the x.509 certificate for authentication but can accept either keyfile or x.509 certificate.
    x509 | Recommended. Send the x.509 certificate for authentication and accept only x.509 certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--nounixsocket
    Disables listening on the UNIX socket. mongos always listens on the UNIX socket, unless either: --nounixsocket is set, bind_ip is not set, or bind_ip does not specify 127.0.0.1.

    New in version 2.6: mongos installed from official .deb and .rpm packages have the bind_ip configuration set to 127.0.0.1 by default.

--unixSocketPrefix <path>
    Specifies a path for the UNIX socket. If this option has no value, mongos creates a socket with /tmp as a prefix.

    MongoDB will always create and listen on a UNIX socket, unless --nounixsocket is set, bind_ip is not set, or bind_ip does not specify 127.0.0.1.

--fork
    Enables a daemon mode for mongos that runs the process in the background. This is the normal mode of operation in production and production-like environments but may not be desirable for testing.

  Sharded Cluster Options

--configdb <config1>,<config2>,<config3>
    Specifies the configuration database for the sharded cluster. You must specify either 1 or 3 configuration servers, in a comma separated list.

    All mongos instances must specify the hosts in the --configdb setting in the in the same order.

    If your configuration databases reside in more that one data center, order the hosts so that the config database that is closest to the majority of your mongos instances is first servers in the list.

    WARNING: Never remove a config server from this setting, even if the config server is not available or offline.

--localThreshold
    Affects the logic that mongos uses when selecting replica set members to pass read operations to from clients. Specify a value in milliseconds. The default value is 15, which corresponds to the default value in all of the client drivers.

    When mongos receives a request that permits reads to secondary members, the mongos will:

•   Find the member of the set with the lowest ping time.

•   Construct a list of replica set members that is within a ping time of 15 milliseconds of the nearest suitable member of the set.

    If you specify a value for --localThreshold, mongos will construct the list of replica members that are within the latency allowed by this value.

•   Select a member to read from at random from this list.

    The ping time used for a member compared by the --localThreshold setting is a moving average of recent ping times, calculated at most every 10 seconds. As a result, some queries may reach members above the threshold until the mongos recalculates the average.

    See the replica-set-read-preference-behavior-member-selection section of the read preference documentation for more information.

--upgrade
    Updates the meta data format used by the config database.

--chunkSize <value>
    Determines the size in megabytes of each chunk in the sharded cluster. The default value is 64 megabytes, which is the ideal size for chunks in most deployments: larger chunk size can lead to uneven data distribution; smaller chunk size can lead to inefficient movement of chunks between nodes. However, in some circumstances it may be necessary to set a different chunk size.

    This option only affects chunk size when you initialize the cluster for the first time. If you later modify the option, the new value has no effect. See the http://docs.mongodb.org/manual/tutorial/modify-chunk-size-in-sharded-cluster procedure if you need to change the chunk size on an existing sharded cluster.

--noAutoSplit
    Prevents mongos from automatically inserting metadata splits in a sharded collection. If set on all mongos instances, this prevents MongoDB from creating new chunks as the data in a collection grows.

    Because any mongos in a cluster can create a split, to totally disable splitting in a cluster you must set --noAutoSplit on all mongos.

    WARNING: With --noAutoSplit enabled, the data in your sharded cluster may become imbalanced over time. Enable with caution.

  SSL Options

  See

http://docs.mongodb.org/manual/tutorial/configure-ssl for full documentation of MongoDB's support.

--sslOnNormalPorts
    Deprecated since version 2.6.

    New in version 2.2.

    Enables SSL so that mongos requires SSL encryption for all connections on the default MongoDB port or port specified by --port.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslMode <mode>
    New in version 2.6.

    Enables SSL or mixed SSL on a port. The argument to the --sslMode option can be one of the following:
    Value | Description
    disabled | The server does not use SSL.
    allowSSL | Connections between servers do not use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    preferSSL | Connections between servers use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    requireSSL | The server uses and accepts only SSL encrypted connections.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has sslCAFile enabled without sslWeakCertificateValidation.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use --sslPEMKeyPassword only if the certificate-key file is encrypted. In all cases, mongos will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify --sslPEMKeyPassword, mongos will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the x.509 certificate-key file for membership authentication for the cluster or replica set.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the x.509 certificate-key file specified with --sslClusterFile. Use --sslClusterPassword only if the certificate-key file is encrypted. In all cases, mongos will redact the password from all logging and reporting output.

    Changed in version 2.6: If the x.509 key file is encrypted and you do not specify --sslClusterPassword, mongos will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCRLFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslWeakCertificateValidation
    New in version 2.4.

    Disables the requirement for SSL certificate validation that --sslCAFile enables. With --sslWeakCertificateValidation, mongos will accept connections when the client does not present a certificate when establishing the connection.

    If the client presents a certificate and mongos has --sslWeakCertificateValidation enabled, mongos will validate the certificate using the root certificate chain specified by --sslCAFile and reject clients with invalid certificates.

    Use --sslWeakCertificateValidation if you have a mixed deployment that includes clients that do not or cannot present certificates to mongos.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the sslAllowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslFIPSMode
    New in version 2.6.

    Directs mongos to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use --sslFIPSMode.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

  Audit Options

--auditDestination
    Enables auditing. The --auditDestination option can have one of the following values:
    Value | Description
    syslog | Output the audit events to syslog in JSON format. Not available on Windows. Audit messages have a syslog severity level of info and a facility level of user. The syslog message limit can result in the truncation of the audit messages. The auditing system will neither detect the truncation nor error upon its occurrence.
    console | Output the audit events to stdout in JSON format.
    file | Output the audit events to the file specified in --auditPath in the format specified in --auditFormat.

    NOTE: The audit system is available only in MongoDB Enterprise.

--auditFormat
    Specifies the format of the output file if --auditDestination is file. The --auditFormat can have one of the following values:
    Value | Description
    JSON | Output the audit events in JSON format to the file specified in --auditPath.
    BSON | Output the audit events in BSON binary format to the file specified in --auditPath.

    Printing audit events to a file in JSON format degrades server performance more than printing to a file in BSON format.

    NOTE: The audit system is available only in MongoDB Enterprise.

--auditPath
    Specifies the output file for auditing if --auditDestination has value of file. The --auditPath option can take either a full path name or a relative path name.

    NOTE: The audit system is available only in MongoDB Enterprise.

--auditFilter
    Specifies the filter to limit the types of operations the audit system records. The option takes a document of the form:

    { atype: <expression> }

    For authentication operations, the option can also take a document of the form:

    { atype: <expression>, "param.db": <database> }

    NOTE: The audit system is available only in MongoDB Enterprise.

  Additional Options

--ipv6
    Enables IPv6 support, which allows mongos to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes, including mongos, disable IPv6 support by default.

--jsonp
    Permits JSONP access via an HTTP interface. Consider the security implications of allowing this activity before enabling this option. If the HTTP interface is disabled, the --jsonp also enables the HTTP interface.

    SEE ALSO: --httpinterface

--noscripting
    Disables the scripting engine.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2014, MongoDB, Inc.